unit Princ;

{   Test de scintillement  }

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, ExtCtrls, StdCtrls ;

type
  TF_Princ = class(TForm)
    PnlTop: TPanel;
    ImgPanel: TPanel;
    ImgHolder: TImage;
    Btn_Afficher: TButton;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure TraceCacheRecSel1(Can : TCanvas; xoSel,yoSel,xeSel,yeSel : Integer );
    procedure ImgHolderMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImgHolderMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImgHolderMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Btn_AfficherClick(Sender: TObject);

    procedure WMERASEBKGND(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
{ ==================================================================== }
  private
  protected
  public
end;

var
  F_Princ : TF_Princ;
  AnchorX, AnchorY,
  CurX, CurY : Integer;
  Bounding : Boolean;

  X0Pix, Y0Pix, X1Pix, Y1Pix : Integer ;
  X0cm, Y0cm, X1cm, Y1cm : Extended ;

  CadreVisible : Boolean ;

  xoSel, yoSel, xeSel, yeSel : integer; // Coordonnes d'origine et d'extrmit du rectangle de slection
  SelVisible, FinSel : boolean;       // Suivi de l'volution de la slection

  Coef : Extended ;
  epTrait : integer;
  clTrait : TColor ;

implementation

Uses   TypInfo ;
{$R *.dfm}

{ ==================================================================== }
procedure TF_Princ.WMERASEBKGND(var Message: TWMEraseBkgnd);
begin
  Message.Result := 1;
end;      
{ ==================================================================== }
procedure TF_Princ.FormCreate(Sender: TObject);
begin
//  F_Princ.DoubleBuffered := True ;
  epTrait := 3 ;
  clTrait := clRed ;
  xoSel := -1 ;
  FinSel := True ;
  SelVisible := False ;
end;
{ ========================================================================== }
procedure TF_Princ.TraceCacheRecSel1(Can : TCanvas; xoSel,yoSel,xeSel,yeSel : Integer );
//        Trace le motif de slection lors d'un 1er appel, et l'efface lors
//        de l'appel suivant avec les mmes paramtres
Var
  XX, YY : Integer ;
  XX1, YY1 : Integer ;
begin
  // Correction pour Stretch de l'image
  Coef  := ImgHolder.Picture.Bitmap.Height / ImgHolder.Height ;
  XX :=  Round(xoSel*Coef) ;
  YY :=  Round(yoSel*Coef) ;
  XX1 :=  Round(xeSel*Coef) ;
  YY1 :=  Round(yeSel*Coef) ;
  Can.pen.mode  := pmNotXor;
  Can.pen.width := epTrait;
  Can.pen.color := clTrait;
  Can.Rectangle(XX,YY,XX1,YY1); // slection Rectangulaire
end;
{ ====================================================================== }
procedure TF_Princ.ImgHolderMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if FinSel and SelVisible then // Effacement d'une slection prxistante par click
    begin
      TraceCacheRecSel1(ImgHolder.Canvas, xoSel,yoSel,xeSel,yeSel);
      SelVisible:=False;
      FinSel:=False;
      xoSel:=-1;
      Exit;
    end;
  FinSel:=False;
  xoSel:=X;
  yoSel:=Y;
end;
{ ====================================================================== }
procedure TF_Princ.ImgHolderMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
 if (xoSel>=0) and (Not FinSel) then
   begin
     if SelVisible Then // alors on l'efface avant de la re-tracer dans la nouvelle position
       TraceCacheRecSel1(ImgHolder.Canvas, xoSel,yoSel,xeSel,yeSel);
     xeSel:=X;
     yeSel:=Y;
     TraceCacheRecSel1(ImgHolder.Canvas, xoSel,yoSel,xeSel,yeSel);
     SelVisible:=true;
   end;
end;
{ ====================================================================== }
procedure TF_Princ.ImgHolderMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FinSel:=True; // Fin de slection
end;
{ ====================================================================== }
procedure TF_Princ.Btn_AfficherClick(Sender: TObject);
// Affichage de l'image
begin
  If OpenDialog1.Execute Then
    Begin
      ImgHolder.Picture.LoadFromFile(Opendialog1.Filename);
      epTrait := ImgHolder.Picture.Bitmap.width  div 140 ;
    End ;
end;
{ ====================================================================== }

End.
